! test_qsort.f90 --- test of qsort implementation in library
!
! Copyright  (C)  2010  Thomas Jahns <jahns@dkrz.de>
!
! Version: 1.0
! Keywords: test quicksort
! Author: Thomas Jahns <jahns@dkrz.de>
! Maintainer: Thomas Jahns <jahns@dkrz.de>
! URL: https://www.dkrz.de/redmine/projects/show/scales-ppm
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
! Commentary:
!
!
!
! Code:
!
PROGRAM test_qsort
  IMPLICIT NONE
  INTEGER, PARAMETER :: maxasize = 30, minasize = 2
  INTEGER, ALLOCATABLE :: a(:)
  INTEGER :: asize, i
  REAL :: rnd
  CALL RANDOM_NUMBER(rnd)
  asize = NINT(rnd*REAL(maxasize - minasize)) + minasize
  ALLOCATE(a(asize))
  DO i = 1, asize
    CALL RANDOM_NUMBER(rnd)
    a(i) = NINT(rnd * REAL(HUGE(a(1))))
  END DO
  CALL quicksort_direct_integer(a, 1, SIZE(a))
  DO i = 2, asize
    IF (a(i) < a(i - 1)) THEN
      PRINT *, "discontinuity at index ", i
      STOP 1
    END IF
  END DO
!  PRINT *, a
CONTAINS
#define QSORTTYPENAME direct_integer
#define TYPEDECL integer
#include "qsort.inc"
  FUNCTION compare_direct_integer(a, b, c) RESULT(cmp)
    INTEGER, INTENT(in) :: a, b, c
    INTEGER :: cmp
    cmp = a - b
  END FUNCTION compare_direct_integer
END PROGRAM test_qsort
!
! Local Variables:
! license-project-url: "https://www.dkrz.de/redmine/projects/show/scales-ppm"
! license-default: "bsd"
! End:
